#!/bin/bash

#Fem els exports necessaris per executar el blast.

export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/

#Generem les carpetes requerides per guardar els resultats del blast.

mkdir blast blastm8 hitsbons blast_hits blastm8_hits

#Definim les variables necessaries per dur a terme el blast: la localització dels genomes i les querys, amb els respectius noms.

for genome_path in `grep 2012 /cursos/BI/genomes/protists/genomes_list_and_info.tab | cut -f 4`; do {
	genome_name=`grep $genome_path /cursos/BI/genomes/protists/genomes_list_and_info.tab | cut -f 1`; 
	
	for query_path in `cat querys_list.tab | cut -f 2`; do {
		query_name=`grep $query_path querys_list.tab | cut -f 1`; 

#Correm el blast.
			
		blastall -p tblastn -i $query_path -d $genome_path -e 0.0001 -o blast/${query_name}.CONTRA.${genome_name}.tblastn 
	
		blastall -p tblastn -i $query_path -d $genome_path -e 0.0001 -o blastm8/${query_name}.CONTRA.${genome_name}.tblastn -m8

		
#Generem uns duplicats dels arxius blast on només tindran contigut els que presentin hits.

		cat blast/${query_name}.CONTRA.${genome_name}.blastp | egrep Value > hitsbons/${query_name}.CONTRA.${genome_name}.tblastn
	} done
} done

#Eliminem tots aquells arxius que no presentin hits

find hitsbons -empty -exec rm '{}' \; 

#Guardem en una llista els noms dels arxius que presenten hits.

ls hitsbons > hitsbons_list.tab 

#Definim una variable que conté els noms dels ar	xius bons, i en fem una copia d'aquests a una altre carpeta, obtindrem els blasts que presentin hits.

for hitsbons in `cat hitsbons_list.tab | cut -f 1`; do {

	cp blast/$hitsbons blast_hits/$hitsbons

	cp blastm8/$hitsbons blastm8_hits/$hitsbons

} done


